<?php

// IPplan v4.31
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("/usr/share/php-adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

$auth = new BasicAuthenticator(ADMINREALM, REALMERROR);

$auth->addUser(ADMINUSER, ADMINPASSWD);

// And now perform the authentication
$auth->authenticate();

// set language
isset($_COOKIE["ipplanNoAuth"]) && myLanguage($_COOKIE['ipplanLanguage']);

//setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Add a user to a group");
newhtml($p);
$w=myheading($p, $title, "admin.php");

// explicitly cast variables as security measure against SQL injection
list($userid, $grp) = myRegister("S:userid S:grp");
$formerror="";

$ds=new IPplanDbf() or myError($w,$p, my_("Could not connect to database"));

if ($_POST) {
   $ds->DbfTransactionStart();
   // emulate mysql REPLACE
   $result=&$ds->ds->Execute("DELETE FROM usergrp
                          WHERE userid=".$ds->ds->qstr($userid)." AND
                             grp=".$ds->ds->qstr($grp));
   $result=&$ds->ds->Execute("INSERT INTO usergrp
                             (userid, grp)
                          VALUES
                             (".$ds->ds->qstr($userid).",
                              ".$ds->ds->qstr($grp).")");

   if ($result) {
      $ds->DbfTransactionEnd();
      insert($w,textbr(my_("User added to group")));
   }
   else {
      $formerror .= my_("User could not be added to group")."\n";
   }
}

myError($w,$p, $formerror, FALSE);

// display opening text
insert($w,heading(3, "$title."));

insert($w, $f2 = form(array("name"=>"ENTRY",
                            "method"=>"post",
                            "action"=>$_SERVER["PHP_SELF"])));

$result1=&$ds->ds->Execute("SELECT userid
                        FROM users
                        ORDER BY userid");
$result2=$ds->GetGrps();

$lst=array();
while($row = $result1->FetchRow()) {
   $col=$row["userid"];
   $lst["$col"]=$row["userid"];
}
if (empty($lst)) {
   myError($w,$p, my_("You first need to create some users!"));
}

insert($f2,textbrbr(my_("User-id")));
insert($f2,selectbox($lst,
                  array("name"=>"userid")));

$lst=array();
while($row = $result2->FetchRow()) {
   $col=$row["grp"];
   $lst["$col"]=$row["grpdescrip"];
}
if (empty($lst)) {
   myError($w,$p, my_("You first need to create some groups!"));
}

insert($f2,textbrbr(my_("Group")));
insert($f2,selectbox($lst,
                  array("name"=>"grp")));

insert($f2,generic("br"));
insert($f2,submit(array("value"=>my_("Submit"))));
insert($f2,freset(array("value"=>my_("Clear"))));

printhtml($p);

?>
